<?php
$file = dirname(__FILE__) . "/../.htaccess"; // 一つ上のディレクトリなら /../.htaccess です。
$remainLastLetter = 0; // 最後に</Files>などある場合は8を入力して文字を保護をしてください。

if (! file_exists($file)) {
    exit(".htaccessファイルが存在しないかアクセスできません。");
}
$ip = $_SERVER["REMOTE_ADDR"];

$addAllowIP = "allow from " . $ip;
$originalHtaccess = file_get_contents($file);
if (strpos($originalHtaccess, $addAllowIP) !== false) {
    exit("すでにIPが登録されています。");
}

$lastLetters = "";
if ($remainLastLetter > 0)
    $lastLetters = substr($originalHtaccess, - $remainLastLetter);
$startLetters = substr($originalHtaccess, 0, strlen($originalHtaccess) - $remainLastLetter);
$newHtaccess = $startLetters . $addAllowIP . "\n" . $lastLetters;
if (file_put_contents($file, $newHtaccess)) {
    echo $ip . "のアクセス許可を与えました";
} else {
    exit(".htaccessファイルの書き込みに失敗しました。アクセス権を確認してください。");
}